//########## Sd.Kfz 251

//### Sound

datablock AudioProfile(gc_Kfz251FireSound)
{
  filename = "./kfzfire.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_bulletBySound)
{
  filename = "./bulletby.wav";
  description = AudioClosestLooping3d;
  preload = true;
};

datablock AudioProfile(gc_bulletHit1Sound)
{
  filename = "./bulletImpact1.wav";
  description = AudioClosest3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_tireParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.4 0.4 0.4 0.3";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 2;
  sizes[1] = 6;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_tireEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_tireParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_vehicleDamageParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = -2;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0";
  colors[1] = "0 0 0 0.5";
  colors[2] = "0 0 0 0";
  sizes[0] = 3;
  sizes[1] = 4;
  sizes[2] = 6;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_vehicleDamageEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_vehicleDamageParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_bulletDebrisExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/chunk";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 1";
  colors[1] = "0 0 0 0";
  sizes[0] = 0.2;
  sizes[1] = 0.2;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_bulletDebrisExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 16;
  velocityVariance = 8;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 30;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_bulletDebrisExplosionParticle";
};

datablock ParticleData(gc_bulletExplosionSmokeParticle)
{
  dragCoefficient = 6;
  gravityCoefficient = 0.2;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1400;
  lifetimeVarianceMS = 200;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.4 0.4 0.4 1";
  colors[1] = "0.2 0.2 0.2 0.2";
  colors[2] = "0 0 0 0";
  sizes[0] = 0.5;
  sizes[1] = 0.6;
  sizes[2] = 5;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_bulletExplosionSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 8;
  periodVarianceMS = 0;
  ejectionVelocity = 9;
  velocityVariance = 8;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 30;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_bulletExplosionSmokeParticle";
};

datablock ExplosionData(gc_mgBulletExplosion)
{
  lifeTimeMS = 50;
  emitter[0] = gc_bulletExplosionSmokeEmitter;
  emitter[1] = gc_bulletDebrisExplosionEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "1 1 1";
  camShakeDuration = 0.5;
  camShakeRadius = 1;
  soundProfile = gc_bulletHit1Sound;
};

datablock ParticleData(gc_Kfz251FlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 0.5 0 1";
  colors[1] = "1 0.8 0.6 1";
  colors[2] = "1 0.3 0.1 0";
  sizes[0] = 0.1;
  sizes[1] = 1.5;
  sizes[2] = 0;
  times[9] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_Kfz251FlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 100;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_Kfz251FlashParticle";
};

datablock ShapeBaseImageData(gc_Kfz251TurretFireImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "Done";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 0.05;
  stateEmitter[0] = gc_Kfz251FlashEmitter;
  stateEmitterTime[0] = 0.05;

  stateName[2] = "Done";
  stateScript[2] = "onDone";
};

function gc_Kfz251TurretFireImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

//### Projectile

AddDamageType("gc_Kfz251",'<bitmap:Add-Ons/Vehicle_Halftrack/CI_kfz251turret>%1','%2<bitmap:Add-Ons/Vehicle_Halftrack/CI_kfz251turret>%1',1,1);

datablock ProjectileData(gc_Kfz251TurretProjectile)
{
  uiName = "";
  projectileShapeName = "";
  directDamage = 25;
  directDamageType = $DamageType::gc_Kfz251;
  radiusDamageType = $DamageType::gc_Kfz251;
  brickExplosionRadius = 0;
  brickExplosionImpact = true;
  brickExplosionForce = 25;
  brickExplosionMaxVolume = 8;
  brickExplosionMaxVolumeFloating = 8;
  impactImpulse = 50;
  explosion = gc_mgBulletExplosion;
  muzzleVelocity = 150;
  verInheritFactor = 1;
  lifetime = 4000;
  fadeDelay = 4000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0.25;
  sound = gc_bulletBySound;
};

//### Turrets

datablock TSShapeConstructor(kfz251turretDts)
{
  baseShape = "./kfz251turret.dts";
  sequence0 = "./root.dsq root";
  sequence1 = "./root.dsq run";
  sequence2 = "./root.dsq walk";
  sequence3 = "./root.dsq back";
  sequence4 = "./root.dsq side";
  sequence5 = "./root.dsq crouch";
  sequence6 = "./root.dsq crouchRun";
  sequence7 = "./root.dsq crouchBack";
  sequence8 = "./root.dsq crouchSide";
  sequence9 = "./look.dsq look";
  sequence10 = "./root.dsq headside";
  sequence11 = "./root.dsq headUp";
  sequence12 = "./root.dsq jump";
  sequence13 = "./root.dsq standjump";
  sequence14 = "./root.dsq fall";
  sequence15 = "./root.dsq land";
  sequence16 = "./root.dsq armAttack";
  sequence17 = "./root.dsq armReadyLeft";
  sequence18 = "./root.dsq armReadyRight";
  sequence19 = "./root.dsq armReadyBoth";
  sequence20 = "./root.dsq spearready";
  sequence21 = "./root.dsq spearThrow";
  sequence22 = "./root.dsq talk";
  sequence23 = "./root.dsq death1";
  sequence24 = "./root.dsq shiftUp";
  sequence25 = "./root.dsq shiftDown";
  sequence26 = "./root.dsq shiftAway";
  sequence27 = "./root.dsq shiftTo";
  sequence28 = "./root.dsq shiftLeft";
  sequence29 = "./root.dsq shiftRight";
  sequence30 = "./root.dsq rotCW";
  sequence31 = "./root.dsq rotCCW";
  sequence32 = "./root.dsq undo";
  sequence33 = "./root.dsq plant";
  sequence34 = "./root.dsq sit";
  sequence35 = "./root.dsq wrench";
  sequence36 = "./fire.dsq fire";
};

datablock PlayerData(gc_Kfz251TurretPlayer)
{
  renderFirstPerson = true;
  emap = false;
  className = Armor;
  shapeFile = "./kfz251turret.dts";
  cameraMaxDist = 4;
  cameraTilt = 0.261;
  cameraVerticalOffset = 2.3;
  cameraDefaultFov = 90;
  cameraMinFov = 5;
  cameraMaxFov = 120;
  aiAvoidThis = true;
//  minLookAngle = -1.5708;
//  maxLookAngle = 0.5;
//  maxFreelookAngle = 3;
  mass = 200000;
  drag = 1;
  density = 5;
  maxDamage = 300;
  maxEnergy = 10;
  repairRate = 0.33;
  rechargeRate = 0.4;
  runForce = 1000;
  runEnergyDrain = 0;
  minRunEnergy = 0;
  maxForwardSpeed = 0;
  maxBackwardSpeed = 0;
  maxSideSpeed = 0;
  maxForwardCrouchSpeed = 0;
  maxBackwardCrouchSpeed = 0;
  maxSideCrouchSpeed = 0;
  maxUnderwaterForwardSpeed = 0;
  maxUnderwaterBackwardSpeed = 0;
  maxUnderwaterSideSpeed = 0;
  jumpForce = 0;
  jumpEnergyDrain = 0;
  minJumpEnergy = 0;
  jumpDelay = 0;
  minJetEnergy = 0;
  jetEnergyDrain = 0;
  canJet = 0;
  minImpactSpeed = 250;
  speedDamageScale = 3.8;
  boundingBox = "8 8 7";
  crouchBoundingBox = "8 8 7";
  pickupRadius = 0.75;
  jetEmitter = "";
  jetGroundEmitter = "";
  jetGroundDistance = 4;
  splash = PlayerSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 0.1;
  splashEmitter[0] = PlayerFoamDropletsEmitter;
  splashEmitter[1] = PlayerFoamEmitter;
  splashEmitter[2] = PlayerBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  runSurfaceAngle = 85;
  jumpSurfaceAngle = 86;
  minJumpSpeed = 20;
  maxJumpSpeed = 30;
  horizMaxSpeed = 68;
  horizResistSpeed = 33;
  horizResistFactor = 0.35;
  upMaxSpeed = 80;
  upResistSpeed = 25;
  upResistFactor = 0.3;
  footstepSplashHeight = 0.35;
  JumpSound = "";
  groundImpactMinSpeed = 10;
  groundImpactShakeFreq = "4 4 4";
  groundImpactShakeAmp = "1 1 1";
  groundImpactShakeDuration = 0.8;
  groundImpactShakeFalloff = 10;
  maxItems = 10;
  maxWeapons = 5;
  maxTools = 5;
  uiName = "";
  rideable = true;
//  lookUpLimit = 0.6;
//  lookDownLimit = 0.4;
  canRide = false;
  showEnergyBar = false;
  paintable = true;
  brickImage = horseBrickImage;
  numMountPoints = 1;
  mountThread[0] = "root";
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = false;
  useCustomPainEffects = true;
  PainHighImage = "";
  PainMidImage = "";
  PainLowImage = "";
  painSound = "";
  deathSound = "";
};

//### Vehicle

datablock WheeledVehicleTire(gc_t90Tire)
{
  shapeFile = "./emptyWheel.dts";
  mass = 10;
  radius = 1;
  staticFriction = 5;
  kineticFriction = 5;
  restitution = 0.5;
  lateralForce = 18000;
  lateralDamping = 4000;
  lateralRelaxation = 0.01;
  longitudinalForce = 14000;
  longitudinalDamping = 2000;
  longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(gc_t90Spring)
{
  length = 0.5;
  force = 6000;
  damping = 2000;
  antiSwayForce = 6;
};

datablock WheeledVehicleTire(gc_kfz251Tire)
{
  shapeFile = "./tire.dts";
  mass = 10;
  radius = 0.65;
  staticFriction = 5;
  kineticFriction = 5;
  restitution = 0.5;
  lateralForce = 18000;
  lateralDamping = 4000;
  lateralRelaxation = 0.01;
  longitudinalForce = 14000;
  longitudinalDamping = 2000;
  longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(gc_kfz251Spring)
{
  length = 0.4;
  force = 6000;
  damping = 1000;
  antiSwayForce = 6;
};

datablock WheeledVehicleData(gc_kfz251Vehicle)
{
  uiName = "Halftrack - Standard";
  category = "Vehicles";
  displayName = "";
  shapeFile = "./kfz251.dts";
  emap = true;
  minMountDist = 6;
  numMountPoints = 6;
  mountThread[0] = "sit";
  mountThread[1] = "root";
  mountThread[2] = "sit";
  mountThread[3] = "sit";
  mountThread[4] = "sit";
  mountThread[5] = "sit";
  maxDamage = 300;
  destroyedLevel = 300;
  speedDamageScale = 1.04;
  collDamageThresholdVel = 20;
  collDamageMultiplier = 0.02;
  massCenter = "0 0 -0.8";
  maxSteeringAngle = 0.7;
  integration = 4;
  tireEmitter = gc_tireEmitter;
  cameraRoll = false;
  cameraMaxDist = 13;
  cameraOffset = 7.5;
  cameraLag = 0.0;
  cameraDecay = 0.75;
  cameraTilt = 0.4;
  collisionTol = 0.1;
  contactTol = 0.1;
  useEyePoint = false;
  defaultTire = gc_t90Tire;
  defaultSpring = gc_t90Spring;
  numWheels = 6;
  mass = 300;
  density = 5;
  drag = 1.6;
  bodyFriction = 0.6;
  bodyRestitution = 0.6;
  minImpactSpeed = 10;
  softImpactSpeed = 10;
  hardImpactSpeed = 15;
  groundImpactMinSpeed = 10;
  engineTorque = 4000;
  engineBrake = 500;
  brakeTorque = 3000;
  maxWheelSpeed = 25;
  rollForce = 900;
  yawForce = 600;
  pitchForce = 1000;
  rotationalDrag = 0.2;
  maxEnergy = 100;
  jetForce = 3000;
  minJetEnergy = 30;
  jetEnergyDrain = 2;
  splash = vehicleSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 1.4;
  splashEmitter[0] = vehicleFoamDropletsEmitter;
  splashEmitter[1] = vehicleFoamEmitter;
  splashEmitter[2] = vehicleBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  softImpactSound = slowImpactSound;
  hardImpactSound = fastImpactSound;
  justcollided = 0;
  rideable = true;
  lookUpLimit = 0.6;
  lookDownLimit = 0.4;
  paintable = true;
  damageEmitter[0] = gc_vehicleDamageEmitter;
  damageEmitterOffset[0] = "0 3 0";
  damageLevelTolerance[0] = 0.5;
  damageEmitter[1] = VehicleBurnEmitter;
  damageEmitterOffset[1] = "0 3 0";
  damageLevelTolerance[1] = 0.9;
  numDmgEmitterAreas = 1;
  initialExplosionProjectile = vehicleExplosionProjectile;
  initialExplosionOffset = 1;
  burnTime = 4000;
  finalExplosionProjectile = vehicleFinalExplosionProjectile;
  finalExplosionOffset = 0.5;
  minRunOverSpeed = 4;
  runOverDamageScale = 25;
  runOverPushScale = 1.2;
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
};

datablock WheeledVehicleData(gc_kfz251MGVehicle : gc_kfz251Vehicle)
{
  uiName = "Halftrack - MG";
  shapeFile = "./kfz251.dts";
};

//### Functions

function gc_kfz251Vehicle::onAdd(%this,%obj)
{
  for(%i=0;%i<%this.numWheels;%i++)
  {
    %obj.setWheelTire(%i,%this.defaultTire);
    %obj.setWheelSpring(%i,%this.defaultSpring);
  }
  %obj.setWheelTire(0,gc_kfz251Tire);
  %obj.setWheelTire(1,gc_kfz251Tire);
  %obj.setWheelSpring(0,gc_kfz251Spring);
  %obj.setWheelSpring(1,gc_kfz251Spring);
  %obj.setWheelSteering(0,1);
  %obj.setWheelSteering(1,1);
  %obj.setWheelSteering(4,-0.8);
  %obj.setWheelSteering(5,-0.8);
  %obj.setWheelPowered(0,false);
  %obj.setWheelPowered(1,false);
  %obj.setWheelPowered(2,true);
  %obj.setWheelPowered(3,true);
  %obj.setWheelPowered(4,true);
  %obj.setWheelPowered(5,true);
}

function gc_kfz251MGVehicle::onAdd(%this,%obj)
{
  for(%i=0;%i<%this.numWheels;%i++)
  {
    %obj.setWheelTire(%i,%this.defaultTire);
    %obj.setWheelSpring(%i,%this.defaultSpring);
  }
  %obj.setWheelTire(0,gc_kfz251Tire);
  %obj.setWheelTire(1,gc_kfz251Tire);
  %obj.setWheelSpring(0,gc_kfz251Spring);
  %obj.setWheelSpring(1,gc_kfz251Spring);
  %obj.setWheelSteering(0,1);
  %obj.setWheelSteering(1,1);
  %obj.setWheelSteering(4,-0.8);
  %obj.setWheelSteering(5,-0.8);
  %obj.setWheelPowered(0,false);
  %obj.setWheelPowered(1,false);
  %obj.setWheelPowered(2,true);
  %obj.setWheelPowered(3,true);
  %obj.setWheelPowered(4,true);
  %obj.setWheelPowered(5,true);
  %t = new AIPlayer() { dataBlock = gc_Kfz251TurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,1);
  %obj.turret = %t;
  %obj.creationTime = getSimTime();
  if(%t.dataBlock !$= gc_Kfz251TurretPlayer) return;
  if(!isObject(%t)) return;
  %parent = %t.getObjectMount();
  if(!isObject(%parent)) return;
  %t.spawnBrick = %parent.spawnBrick;
  %t.brickGroup = %parent.brickGroup;
}

function gc_Kfz251MGVehicle::onRemove(%this,%obj) { if(isObject(%obj.turret)) %obj.turret.delete(); }

package gc_Kfz251Package
{
  function gc_Kfz251Vehicle::Damage(%this,%obj,%source,%pos,%amout,%type)
  {
    if(%amout <= 50) %amout *= 0.75;
    parent::Damage(%this,%obj,%source,%pos,%amout,%type);
  }
  function Player::Burn(%obj,%time)
  {
    if(%obj.dataBlock $= gc_Kfz251TurretPlayer) return;
    parent::Burn(%obj,%time);
  }
  function ShapeBase::setNodeColor(%obj,%node,%color)
  {
    parent::setnodecolor(%obj,%node,%color);
    if(isObject(%obj.turret)) %obj.turret.setNodeColor("ALL",%color);
  }
  function gc_Kfz251MGVehicle::Damage(%this,%obj,%source,%pos,%amout,%type)
  {
    if(%amout <= 50) %amout *= 0.75;
    if((%obj.getDamageLevel()+%amout) >= %this.maxDamage)
    {
      if(%obj.destroyed) return;
      %obj.setNodeColor("ALL","0 0 0 1");
      if(isObject(%obj.turret))
      {
        %obj.turret.delete();
        %p = new Projectile()
        {
          dataBlock = vehicleFinalExplosionProjectile;
          initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
          initialVelocity = "0 0 1";
          client = %obj.lastDamageClient;
          sourceClient = %obj.lastDamageClient;
        };
        MissionCleanup.add(%p);
      }
      else
      {
        %p = new Projectile()
        {
          dataBlock = vehicleExplosionProjectile;
          initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
          initialVelocity = "0 0 1";
          client = %obj.lastDamageClient;
          sourceClient = %obj.lastDamageClient;
        };
        MissionCleanup.add(%p);
      }
      if(%obj.destroyed) return;
      %obj.setDamageLevel(%this.maxDamage);
      %obj.destroyed = 1;
      %obj.schedule(%this.burnTime,"finalExplosion");
      if(isObject(%obj.spawnBrick.client.minigame)) %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
      %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
    }
    else
      parent::Damage(%this,%obj,%source,%pos,%amout,%type);
  }
  function Player::emote(%obj,%emote)
  {
    if(%obj.dataBlock $= gc_Kfz251TurretPlayer) return;
    parent::emote(%obj,%emote);
  }
  function gc_Kfz251TurretPlayer::onDisabled(%this,%obj,%state)
  {
    %tank = %obj.getObjectMount();
    if(isObject(%tank)) %pos = vectorAdd(%obj.getObjectMount().getPosition(),"0 0" SPC %obj.getObjectMount().dataBlock.initialExplosionOffset);
    else
      %pos = %obj.getHackPosition();
    %p = new Projectile()
    {
      dataBlock = vehicleFinalExplosionProjectile;
      initialPosition = %pos;
      initialVelocity = "0 0 1";
      client = %obj.lastDamageClient;
      sourceClient = %obj.lastDamageClient;
    };
    MissionCleanup.add(%p);
    %obj.schedule(10,"delete");
    if(isObject(%tank))
    {
      %player = %obj.getMountedObject(0);
      if(isObject(%player)) %obj.getObjectMount().schedule(10,"mountObject",%player,2);
    }
    if(!isObject(%tank))
    {
      if(isObject(%obj.spawnBrick))
      {
        %mg = getMiniGameFromObject(%obj);
        if(isObject(%mg)) %obj.spawnBrick.spawnVehicle(%mg.vehicleReSpawnTime);
        else
          %obj.spawnBrick.spawnVehicle(0);
      }
      parent::onDisabled(%this,%obj,%state);
    }
  }
  function armor::onMount(%this,%obj,%col,%slot)
  {
    parent::onMount(%this,%obj,%col,%slot);
    if(isObject(%obj.client))
    {
      if(%col.getDataBlock() == gc_Kfz251TurretPlayer.getId()) ServerCmdUnUseTool(%obj.client);
    }
  }
  function armor::onTrigger(%this,%obj,%triggerNum,%val)
  {
    %mount = %obj.getObjectMount();
    if(isObject(%mount))
    {
      if(!%val) cancel(%obj.gc_Kfz251TurretLoop);
      if(%mount.getDataBlock() == gc_Kfz251TurretPlayer.getId() && %triggerNum == 0 && %val)
        %obj.gc_Kfz251TurretFire(%val);
    }
    parent::onTrigger(%this,%obj,%triggerNum,%val);
  }
  function Player::gc_Kfz251TurretFire(%obj,%val)
  {
    if(!%val) { cancel(%obj.gc_Kfz251TurretLoop); return; }
    if(!isObject(%obj.getObjectMount())) { cancel(%obj.gc_Kfz251TurretLoop); return; }
    if(%obj.getObjectMount().getDataBlock() != gc_Kfz251TurretPlayer.getId()) { cancel(%obj.gc_Kfz251TurretLoop); return; }
    %client = %obj.client;
    if(isObject(%client)) ServerCmdUnUseTool(%client);
    %mount = %obj.getObjectMount();
    %scaleFactor = getWord(%mount.getScale(),2);
    %p = new Projectile()
    {
      dataBlock = gc_Kfz251TurretProjectile;
      initialPosition = %mount.getSlotTransform(1);
      initialVelocity = MatrixMulVector(MatrixCreateFromEuler(((getRandom()-0.5)*0.02) SPC ((getRandom()-0.5)*0.02) SPC ((getRandom()-0.5)*0.02)),VectorScale(%mount.getMuzzleVector(1),200));
      sourceObject = %obj;
      client = %client;
      sourceSlot = 0;
      originPoint = %mount.getSlotTransform(1);
      sourceVehicle = %mount.getObjectMount();
    };
    MissionCleanup.add(%p);
    %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
    %mount.mountImage(gc_Kfz251TurretFireImage,1);
    %mount.playThread(0,fire);
    serverPlay3D(gc_Kfz251FireSound,%obj.getPosition());
    %obj.gc_Kfz251TurretLoop = %obj.schedule(150,gc_Kfz251TurretFire,%val);
    return;
  }
};
activatepackage(gc_Kfz251Package);

function gc_Kfz251TurretProjectile::onCollision(%this,%obj,%col,%fade,%pos,%norm)
{
  if(%col == %obj.sourceVehicle) return;
  parent::onCollision(%this,%obj,%col,%fade,%pos,%norm);
}
